Default Value

SpreadJS supports setting a cell default value which can be a value or a formula. You can enter data in a cell that has a default value/formula, and it will not be overridden.

The defaultValue API is used to set a default value/formula to a cell, so that when the cell is empty, it will display the default value or the value calculated from a default formula. When an empty cell has a default value/formula applied to it and a user edits that cell, the default value will not be overridden. The APIs are as follows:
window.onload = function () { let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1}); spread.suspendPaint(); let sheet = spread.getActiveSheet(); let fbx = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('formula'), {rangeSelectMode: true}); fbx.workbook(spread); initSpread(spread, fbx); bindEvents(spread); spread.resumePaint(); }; function bindEvents(spread) { spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () { getDefault(spread.getActiveSheet()); }); spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function () { self.getDefault(spread.getActiveSheet()); }); } function getDefault(sheet) { let selections = sheet.getSelections(), showDefault = document.getElementById('showDefault'); if (!selections || selections.length === 0) { showDefault.value = ''; return; } let sel = selections[0], row = sel.row, col = sel.col; if (sel.rowCount === 1 && sel.colCount === 1) { showDefault.value = sheet.getDefaultValue(row, col); } else { showDefault.value = ''; } } function convertValue (value) { if (!value) { return value; } // try to convert to number let num = Number(value); if (!isNaN(num)) { return num; } // try to convert to boolean if (value.toLowerCase() === "true" || value.toLowerCase() === "false") { return value.toLowerCase() === "true"; } // try to convert to date let date = new Date(value); if (!isNaN(date.getTime())) { return date; } return value; } function initSpread(spread, fbx) { fetch(getFileUrl()).then(res => res.blob()).then(file => { spread.open(file, () => { let sheet = spread.getActiveSheet(); sheet.suspendPaint(); sheet.suspendCalcService(); for (let i = 0; i < 12; i++) { sheet.getCell(2, 3 + i, 3).defaultValue('=$B3/12'); sheet.getCell(3, 3 + i, 3).defaultValue('=$B4/12'); } sheet.resumeCalcService(); sheet.resumePaint(); getDefault(spread.getActiveSheet()); }); }); document.getElementById('btnSetDefault').onclick = function () { let value = document.getElementById('value').value; let formula = fbx.text(); sheet = spread.getActiveSheet(); let selections = sheet.getSelections(); if (!selections || selections.length === 0) { return; } sheet.suspendPaint(); let length = selections.length; for (let i = 0; i < length; i++) { let sel = selections[i], rowIndex = sel.row, colIndex = sel.col, rowCount = sel.rowCount, colCount = sel.colCount, maxRow = rowIndex + rowCount, maxColumn = colIndex + colCount, r, c; if (rowIndex !== -1 && colIndex !== -1) { for (r = rowIndex; r < maxRow; r++) { for (c = colIndex; c < maxColumn; c++) { sheet.setDefaultValue(r, c, formula || convertValue(value)); } } } } sheet.resumePaint(); getDefault(sheet); }; } function getFileUrl () { return '$DEMOROOT$/spread/source/data/defaultValue.sjs'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-io/dist/gc.spread.sheets.io.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <p> <span>You can set, get the default value and formula for the active cells.</span> </p> </div> <div class="option-row"> <label for="value">Default Value: </label> <input id="value" /> </div> <div class="option-row"> <label for="formula">Default Formula: </label> <div id="formula" spellcheck="false" style="border: 1px solid #808080;width:100%;height:21px;overflow:hidden;"></div> </div> <div class="option-row"> <input type="button" id="btnSetDefault" value="Set Default" title="Set default value and formula to selected item(s)" /> </div> <div class="option-row"> <label for="showDefault">Get Default Value: </label> <textarea id="showDefault" cols="31" readonly></textarea> </div> </div> </div></body> </html>
.sample { position: relative; height: 100%; overflow: auto; } .sample::after { display: block; content: ""; clear: both; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { display: inline-block; margin-bottom: 6px; } input { padding: 4px; width: 100%; margin: 0 4px 4px 0; box-sizing: border-box; } input[type=button] { width: 30%; } p { background-color: #F4F8EB; padding: 4px; } p span { display: block; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Default Value

SpreadJS supports setting a cell default value which can be a value or a formula. You can enter data in a cell that has a default value/formula, and it will not be overridden.

Description
app.vue
index.html
Copy to CodeMine

The defaultValue API is used to set a default value/formula to a cell, so that when the cell is empty, it will display the default value or the value calculated from a default formula.

When an empty cell has a default value/formula applied to it and a user edits that cell, the default value will not be overridden.

The APIs are as follows:

///* function defaultValue(value?: any): any
/**
 * Gets or sets the default value of the cell.
 * @param {Object} [value] The cell default value.
 * @returns {Object|GC.Spread.Sheets.CellRange} If no value is set, returns the cell default value; otherwise, returns the cell.
 * @example
 * activeSheet.getCell(1,1).defaultValue(10);
 * activeSheet.getCell(1,3).defaultValue("=LastYear+1000");
 */
 defaultValue: (value?: any) => (object | CellRange);

 ///* function getDefaultValue(row: number, col: number): any
/**
  * Gets the default value from the specified cell.
  * @param {number} row The row index.
  * @param {number} col The column index.
  * @returns {Object | string} Returns the default value of cell.
  * @example
  * sheet.setDefaultValue(0, 0, 20);
  * let defaultValue = sheet.getDefaultValue(0, 0);
  * let value = sheet.getValue(0, 0); // the value equals to defaultValue
  */
getDefaultValue (row: number, col: number): any;

///* function setDefaultValue(row: number, col: number, value: any): void
/**
  * Sets the default value to the cell, it can be the value data or the formula string. It works when the cell has no data.
  * @param {number} row The row index.
  * @param {number} col The column index.
  * @param {Object | string} value The default value of the cell.
  * @example
  * sheet.setDefaultValue(0, 0, "name");
  * sheet.setDefaultValue(0, 1, "=A1");
  */
setDefaultValue (row: number, col: number, value: any): void;

///* enum GC.Spread.Sheets.CopyToOptions
/**
 * Specifies the copy to option.
 * @enum {number}
 */
export enum CopyToOptions {
  ...
  defaultValue: 2048
}
The defaultValue API is used to set a default value/formula to a cell, so that when the cell is empty, it will display the default value or the value calculated from a default formula. When an empty cell has a default value/formula applied to it and a user edits that cell, the default value will not be overridden. The APIs are as follows:
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> <gc-worksheet></gc-worksheet> <gc-worksheet /> </gc-spread-sheets> <div class="options-container"> <div class="option-row"> <p> <span>You can set, get the default value and formula for the active cells.</span> </p> </div> <div class="option-row"> <label for="value">Default Value: </label> <input id="value" v-model="value" /> </div> <div class="option-row"> <label for="formula">Default Formula: </label> <div id="formula" spellcheck="false" style="border: 1px solid #808080;width:100%;height:21px;overflow:hidden;"> </div> </div> <div class="option-row"> <input type="button" id="btnSetDefault" value="Set Default" title="Set default value and formula to selected item(s)" @click="handleSetDefault" /> </div> <div class="option-row"> <label for="showDefault">Get Default Value: </label> <textarea id="showDefault" cols="31" readonly v-model="showDefault"></textarea> </div> </div> </div> </template> <script setup> import '@mescius/spread-sheets-vue' import "@mescius/spread-sheets-io"; import { ref, computed } from "vue"; import GC from "@mescius/spread-sheets"; const spread = ref(null); const fbx = ref(null); const value = ref(''); const showDefault = ref(''); const getFileUrl = () => { return '$DEMOROOT$/spread/source/data/defaultValue.sjs'; } const initSpread = (spreadInstance) => { spread.value = spreadInstance; fbx.value = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('formula'), { rangeSelectMode: true }); fbx.value.workbook(spreadInstance); fetch(getFileUrl()).then(res => res.blob()).then(file => { spreadInstance.open(file, () => { let sheet = spreadInstance.getActiveSheet(); sheet.suspendPaint(); sheet.suspendCalcService(); for (let i = 0; i < 12; i++) { sheet.getCell(2, 3 + i, 3).defaultValue('=$B3/12'); sheet.getCell(3, 3 + i, 3).defaultValue('=$B4/12'); } sheet.resumeCalcService(); sheet.resumePaint(); getDefault(spreadInstance); }); }); bindEvents(spreadInstance); }; const bindEvents = (spreadInstance) => { spreadInstance.bind(GC.Spread.Sheets.Events.SelectionChanged, () => { getDefault(spreadInstance); }); spreadInstance.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, () => { getDefault(spreadInstance); }); }; const handleSetDefault = () => { let sheet = spread.value.getActiveSheet(); let val = value.value; let selections = sheet.getSelections(); if (!selections || selections.length === 0) { return; } sheet.suspendPaint(); let length = selections.length; for (let i = 0; i < length; i++) { let sel = selections[i], rowIndex = sel.row, colIndex = sel.col, rowCount = sel.rowCount, colCount = sel.colCount, maxRow = rowIndex + rowCount, maxColumn = colIndex + colCount, r, c; if (rowIndex !== -1 && colIndex !== -1) { for (r = rowIndex; r < maxRow; r++) { for (c = colIndex; c < maxColumn; c++) { sheet.setDefaultValue(r, c, fbx.value.text() || convertValue(val)); } } } } sheet.resumePaint(); getDefault(spread.value); }; const getDefault = (spreadInstance) => { let sheet = spreadInstance.getActiveSheet(), selections = sheet.getSelections(); if (!selections || selections.length === 0) { showDefault.value = ''; return; } let sel = selections[0], row = sel.row, col = sel.col; showDefault.value = sheet.getDefaultValue(row, col) || ''; }; const convertValue = (val) => { if (!val) { return val; } // try to convert to number let num = Number(val); if (!isNaN(num)) { return num; } // try to convert to boolean if (val.toLowerCase() === "true" || val.toLowerCase() === "false") { return val.toLowerCase() === "true"; } // try to convert to date let date = new Date(val); if (!isNaN(date.getTime())) { return date; } return val; }; </script> <style scoped> .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { display: inline-block; margin-bottom: 6px; } input { padding: 4px; width: 100%; margin: 0 4px 4px 0; box-sizing: border-box; } input[type=button] { width: 30%; } p { background-color: #F4F8EB; padding: 4px; } p span { display: block; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);

Default Value

SpreadJS supports setting a cell default value which can be a value or a formula. You can enter data in a cell that has a default value/formula, and it will not be overridden.

Description
app.jsx
app-class.jsx
index.html
styles.css
Copy to CodeMine

The defaultValue API is used to set a default value/formula to a cell, so that when the cell is empty, it will display the default value or the value calculated from a default formula.

When an empty cell has a default value/formula applied to it and a user edits that cell, the default value will not be overridden.

The APIs are as follows:

///* function defaultValue(value?: any): any
/**
 * Gets or sets the default value of the cell.
 * @param {Object} [value] The cell default value.
 * @returns {Object|GC.Spread.Sheets.CellRange} If no value is set, returns the cell default value; otherwise, returns the cell.
 * @example
 * activeSheet.getCell(1,1).defaultValue(10);
 * activeSheet.getCell(1,3).defaultValue("=LastYear+1000");
 */
 defaultValue: (value?: any) => (object | CellRange);

 ///* function getDefaultValue(row: number, col: number): any
/**
  * Gets the default value from the specified cell.
  * @param {number} row The row index.
  * @param {number} col The column index.
  * @returns {Object | string} Returns the default value of cell.
  * @example
  * sheet.setDefaultValue(0, 0, 20);
  * let defaultValue = sheet.getDefaultValue(0, 0);
  * let value = sheet.getValue(0, 0); // the value equals to defaultValue
  */
getDefaultValue (row: number, col: number): any;

///* function setDefaultValue(row: number, col: number, value: any): void
/**
  * Sets the default value to the cell, it can be the value data or the formula string. It works when the cell has no data.
  * @param {number} row The row index.
  * @param {number} col The column index.
  * @param {Object | string} value The default value of the cell.
  * @example
  * sheet.setDefaultValue(0, 0, "name");
  * sheet.setDefaultValue(0, 1, "=A1");
  */
setDefaultValue (row: number, col: number, value: any): void;

///* enum GC.Spread.Sheets.CopyToOptions
/**
 * Specifies the copy to option.
 * @enum {number}
 */
export enum CopyToOptions {
  ...
  defaultValue: 2048
}
The defaultValue API is used to set a default value/formula to a cell, so that when the cell is empty, it will display the default value or the value calculated from a default formula. When an empty cell has a default value/formula applied to it and a user edits that cell, the default value will not be overridden. The APIs are as follows:
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { App } from './app-class'; ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react'; import GC from '@mescius/spread-sheets'; import '@mescius/spread-sheets-io'; import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react'; import './styles.css'; const Component = React.Component; export class App extends Component { constructor(props) { super(props); this.spread = null; this.fbx = null; this.state = { showDefault: '', value: '' } this.handleShowDefault = this.handleShowDefault.bind(this); } render() { return (<div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => this.initSpread(spread)}> <Worksheet></Worksheet> </SpreadSheets> </div> <Panel showDefault={this.state.showDefault} value = {this.state.value} handleSetDefault={(e) => { this.handleSetDefault(e) }} handleShowDefault={(e)=>{this.handleShowDefault(e)}} handleSetDefaultValue={(e)=>{this.handleSetDefaultValue(e)}} /> </div>); } initSpread(spread) { this.spread = spread; this.fbx = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('formula'), {rangeSelectMode: true}); this.fbx.workbook(spread); fetch(this.getFileUrl()).then(res => res.blob()).then((file) => { spread.open(file, () => { let sheet = spread.getActiveSheet(); sheet.suspendPaint(); sheet.suspendCalcService(); for (let i = 0; i < 12; i++) { sheet.getCell(2, 3 + i, 3).defaultValue('=$B3/12'); sheet.getCell(3, 3 + i, 3).defaultValue('=$B4/12'); } sheet.resumeCalcService(); sheet.resumePaint(); this.getDefault(spread); }); }); this.bindEvents(spread); } getFileUrl () { return '$DEMOROOT$/spread/source/data/defaultValue.sjs'; } bindEvents(spread) { let self = this; spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () { self.getDefault(spread); }); spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function () { self.getDefault(spread); }); } handleShowDefault(e){ this.setState({ showDefault: e.target.value }); } handleSetDefaultValue (e) { this.setState({ value: e.target.value }); } handleSetDefault(e) { let spread = this.spread; let sheet = spread.getActiveSheet(); let value = this.state.value; let selections = sheet.getSelections(); if (!selections || selections.length === 0) { return; } sheet.suspendPaint(); let length = selections.length; for (let i = 0; i < length; i++) { let sel = selections[i], rowIndex = sel.row, colIndex = sel.col, rowCount = sel.rowCount, colCount = sel.colCount, maxRow = rowIndex + rowCount, maxColumn = colIndex + colCount, r, c; if (rowIndex !== -1 && colIndex !== -1) { for (r = rowIndex; r < maxRow; r++) { for (c = colIndex; c < maxColumn; c++) { sheet.setDefaultValue(r, c, this.fbx.text() || this.convertValue(value)); } } } } sheet.resumePaint(); this.getDefault(spread); } getDefault(spread) { let sheet = spread.getActiveSheet(), selections = sheet.getSelections(); if (!selections || selections.length === 0) { this.setState({ showDefault: '' }); return; } let sel = selections[0], row = sel.row, col = sel.col; this.setState({ showDefault: sheet.getDefaultValue(row, col) || '' }); } convertValue (value) { if (!value) { return value; } // try to convert to number let num = Number(value); if (!isNaN(num)) { return num; } // try to convert to boolean if (value.toLowerCase() === "true" || value.toLowerCase() === "false") { return value.toLowerCase() === "true"; } // try to convert to date let date = new Date(value); if (!isNaN(date.getTime())) { return date; } return value; } } class Panel extends Component { constructor(props) { super(props); } render() { const {handleSetDefault, handleSetDefaultValue} = this.props; return ( <div class="options-container"> <div class="option-row"> <p> <span>You can set, get the default value and formula for the active cells.</span> </p> </div> <div class="option-row"> <label for="value">Default Value: </label> <input id="value" value={this.props.value} onChange = {(e)=>{handleSetDefaultValue(e)}} /> </div> <div class="option-row"> <label for="formula">Default Formula: </label> <div id="formula" spellcheck="false" style={{border: '1px solid #808080', width:'100%', height:'21px', overflow:'hidden'}}></div> </div> <div class="option-row"> <input type="button" id="btnSetDefault" value="Set Default" title="Set default value and formula to selected item(s)" onClick={(e) => { handleSetDefault(this.state) }} /> </div> <div class="option-row"> <label for="showDefault">Get Default Value: </label> <textarea id="showDefault" cols="31" readOnly value={this.props.showDefault}></textarea> </div> </div> ) } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app"></div> </body> </html>
.sample { position: relative; height: 100%; overflow: auto; } .sample::after { display: block; content: ""; clear: both; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { display: inline-block; margin-bottom: 6px; } input { padding: 4px; width: 100%; margin: 0 4px 4px 0; box-sizing: border-box; } input[type=button] { width: 30%; } p { background-color: #F4F8EB; padding: 4px; } p span { display: block; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

The defaultValue API is used to set a default value/formula to a cell, so that when the cell is empty, it will display the default value or the value calculated from a default formula.
When an empty cell has a default value/formula applied to it and a user edits that cell, the default value will not be overridden.
The APIs are as follows:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-io';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
value: any = '';
fbx: GC.Spread.Sheets.FormulaTextBox.FormulaTextBox;
showDefault: string = "";
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
this.fbx = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('formula'), {rangeSelectMode: true});
this.fbx.workbook(spread);
fetch(this.getFileUrl()).then(res => res.blob()).then((file: any) => {
spread.open(file, () => {
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
sheet.suspendCalcService();
for (let i = 0; i < 12; i++) {
sheet.getCell(2, 3 + i, 3).defaultValue('=$B3/12');
sheet.getCell(3, 3 + i, 3).defaultValue('=$B4/12');
}
sheet.resumeCalcService();
sheet.resumePaint();
this.getDefault(spread);
});
});
this.bindEvents(spread);
}
getFileUrl () {
return '$DEMOROOT$/spread/source/data/defaultValue.sjs';
}
bindEvents(spread: GC.Spread.Sheets.Workbook) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.getDefault(spread);
});
spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function () {
self.getDefault(spread);
});
}
handleSetDefault () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let value = this.value;
let selections = sheet.getSelections();
if (!selections || selections.length === 0) {
return;
}
sheet.suspendPaint();
let length = selections.length;
for (let i = 0; i < length; i++) {
let sel = selections[i],
rowIndex = sel.row,
colIndex = sel.col,
rowCount = sel.rowCount,
colCount = sel.colCount,
maxRow = rowIndex + rowCount,
maxColumn = colIndex + colCount,
r, c;
if (rowIndex !== -1 && colIndex !== -1) {
for (r = rowIndex; r < maxRow; r++) {
for (c = colIndex; c < maxColumn; c++) {
sheet.setDefaultValue(r, c, this.fbx.text() || this.convertValue(value));
}
}
}
}
sheet.resumePaint();
this.getDefault(spread);
}
getDefault (spread: GC.Spread.Sheets.Workbook) {
let sheet = spread.getActiveSheet(), selections = sheet.getSelections();
if (!selections || selections.length === 0) {
this.showDefault = '';
return;
}
let sel = selections[0], row = sel.row, col = sel.col;
this.showDefault = sheet.getDefaultValue(row, col) || '';
}
convertValue (value: any) {
if (!value) {
return value;
}
// try to convert to number
let num = Number(value);
if (!isNaN(num)) {
return num;
}
// try to convert to boolean
if (value.toLowerCase() === "true" || value.toLowerCase() === "false") {
return value.toLowerCase() === "true";
}
// try to convert to date
let date = new Date(value);
if (!isNaN(date.getTime())) {
return date;
}
return value;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule ],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<p>
<span>You can set, get the default value and formula for the active cells.</span>
</p>
</div>
<div class="option-row">
<label for="value">Default Value: </label>
<input id="value" [(ngModel)]="value" />
</div>
<div class="option-row">
<label for="formula">Default Formula: </label>
<div id="formula" spellcheck="false" style="border: 1px solid #808080;width:100%;height:21px;overflow:hidden;"></div>
</div>
<div class="option-row">
<input type="button" id="btnSetDefault" value="Set Default" title="Set default value and formula to selected item(s)" (click) = "handleSetDefault()" />
</div>
<div class="option-row">
<label for="showDefault">Get Default Value: </label>
<textarea id="showDefault" cols="31" readonly [(ngModel)]="showDefault"></textarea>
</div>
</div>
</div>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: inline-block;
margin-bottom: 6px;
}
input {
padding: 4px;
width: 100%;
margin: 0 4px 4px 0;
box-sizing: border-box;
}
input[type=button] {
width: 30%;
}
p {
background-color: #F4F8EB;
padding: 4px;
}
p span {
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);